/* AdminController - http://gate.ac.uk/ - (c) Univ Shef - GPL licenced */

package gate.calf
import groovy.sql.Sql

class AdminController {

  def treeService
  def dataSource

  def index = {
    treeService.analyse(params.path ?: "")
    [ request: request, treeService: treeService ]
  }

  def db = {
    File tmpFile = File.createTempFile("db-dump-", ".script")
    tmpFile.deleteOnExit()
    String fname = tmpFile.path

    Sql sql = new Sql(dataSource)
    boolean status = sql.execute("SCRIPT TO ${fname}")
    String dump = tmpFile.text
    tmpFile.delete()

    render(
      text: "<html><body><h1>DB dump</h1><!--(status ${status}; file ${fname})--><hr/><pre>${dump}</pre></body></html>",
      contentType: "text/html",
      encoding: "UTF-8"
    )
  }

}
